% Aryeh Drager
% Math 53 Project - Finding Lyapunov Exponents
% Adapted from lyapflow.m by Prof. Barnett

% Model with J variables
% Requires functions: finddxdt.m, time1map.m, findDf.m, findDFdt.m

clear

j = 40; % number of points
dt = 0.02; % time step, in "pentadays" (1 pentaday := 5 days)
t_step = 1; % time-WHAT? map
F = 8; % forcing term
loops = 500; % Number of averaging loops
itsperloop = 15; % Number of time-1 iterations per loop
total_iterations = 1 + loops.*itsperloop;
x = zeros(j,total_iterations); % initialize model
current_iteration = 1;
% perturb
x(:,1) = F.*ones(j,1);
x(20,1) = 1.001.*x(20,1);
%x(21,1) = 1.001.*x(20,1);
h = zeros(j,1); % place to store averaged Lyapunov exponents
for m = 1:loops
    J = eye(j);
    for n = 1:itsperloop
        [x_new Jx] = time1map(x(:,current_iteration),j,F,dt,t_step);
        current_iteration = current_iteration + 1;
        x(:,current_iteration) = x_new;
        J = Jx*J; % Update Jacobian
        [Q,R] = qr(J);                   % re-orthogonalize
        J = Q*diag(diag(R));             % but keep them correct lengths
    end
    rN = abs(diag(R));                  % DON'T print out progress
    h = h + log(rN)/itsperloop;                 % sum up lyap exps from each run
    
end
h = h/loops                          % final answer: mean (over runs) of lyap exps

